diff --git a/drupal7/sites/all/modules/views/includes/cache.inc b/drupal7/sites/all/modules/views/includes/cache.inc
index 59c1733d..b74752f1 100644
--- a/drupal7/sites/all/modules/views/includes/cache.inc
+++ b/drupal7/sites/all/modules/views/includes/cache.inc
@@ -23,16 +23,31 @@ function _views_fetch_data($table = NULL, $move = TRUE, $reset = FALSE) {
   if ($table) {
     if (!isset($cache[$table])) {
       $cid = 'views_data:' . $table;
-      $data = views_cache_get($cid, TRUE);
-      if (!empty($data->data)) {
+      if ($data = views_cache_get($cid, TRUE)) {
         $cache[$table] = $data->data;
       }
       else {
         if (!$fully_loaded) {
-          // No cache entry, rebuild.
-          $cache = _views_fetch_data_build();
+          // Try to load the full views cache.
+          if ($data = views_cache_get('views_data', TRUE)) {
+            $cache = $data->data;
+          }
+          else {
+            // No cache entry, rebuild.
+            $cache = _views_fetch_data_build();
+          }
           $fully_loaded = TRUE;
         }
+
+        // Write back a cache for this table.
+        if (isset($cache[$table])) {
+          views_cache_set($cid, $cache[$table], TRUE);
+        }
+        else {
+          // If there is still no information about that table, it is missing.
+          // Write an empty array to avoid repeated rebuilds.
+          views_cache_set($cid, array(), TRUE);
+        }
       }
     }
     if (isset($cache[$table])) {
@@ -82,11 +97,6 @@ function _views_fetch_data_build() {
 
   // Keep a record with all data.
   views_cache_set('views_data', $cache, TRUE);
-  // Save data in seperate cache entries.
-  foreach ($cache as $key => $data) {
-    $cid = 'views_data:' . $key;
-    views_cache_set($cid, $data, TRUE);
-  }
   return $cache;
 }
 
diff --git a/drupal7/sites/all/modules/views/includes/handlers.inc b/drupal7/sites/all/modules/views/includes/handlers.inc
index 2a33d5d5..43461331 100644
--- a/drupal7/sites/all/modules/views/includes/handlers.inc
+++ b/drupal7/sites/all/modules/views/includes/handlers.inc
@@ -1581,7 +1581,7 @@ class views_join {
             // With an array of values, we need multiple placeholders and the
             // 'IN' operator is implicit.
             foreach ($info['value'] as $value) {
-              $placeholder_i = ':views_join_condition_' . $select_query->nextPlaceholder();
+              $placeholder_i = $view_query->placeholder('views_join_condition_');
               $arguments[$placeholder_i] = $value;
             }
 
@@ -1591,10 +1591,9 @@ class views_join {
           else {
             // With a single value, the '=' operator is implicit.
             $operator = !empty($info['operator']) ? $info['operator'] : '=';
-            $placeholder = ':views_join_condition_' . $select_query->nextPlaceholder();
+            $placeholder = $view_query->placeholder('views_join_condition_');
             $arguments[$placeholder] = $info['value'];
           }
-
           $extras[] = "$join_table$info[field] $operator $placeholder";
         }
 
diff --git a/drupal7/sites/all/modules/views/includes/view.inc b/drupal7/sites/all/modules/views/includes/view.inc
index d8c0c1f5..d082a0b6 100644
--- a/drupal7/sites/all/modules/views/includes/view.inc
+++ b/drupal7/sites/all/modules/views/includes/view.inc
@@ -756,7 +756,7 @@ class view extends views_db_object {
    */
   function _init_handler($key, $info) {
     // Load the requested items from the display onto the object.
-    $this->$key = $this->display_handler->get_handlers($key);
+    $this->$key = &$this->display_handler->get_handlers($key);
 
     // This reference deals with difficult PHP indirection.
     $handlers = &$this->$key;
diff --git a/drupal7/sites/all/modules/views/js/ajax_view.js b/drupal7/sites/all/modules/views/js/ajax_view.js
index e3bc8213..780691c4 100644
--- a/drupal7/sites/all/modules/views/js/ajax_view.js
+++ b/drupal7/sites/all/modules/views/js/ajax_view.js
@@ -66,6 +66,11 @@ Drupal.views.ajaxView = function(settings) {
     // to a given element.
     .filter(jQuery.proxy(this.filterNestedViews, this))
     .once(jQuery.proxy(this.attachPagerAjax, this));
+
+  // Add a trigger to update this view specifically.
+  var self_settings = this.element_settings;
+  self_settings.event = 'RefreshView';
+  this.refreshViewAjax = new Drupal.ajax(this.selector, this.$view, self_settings);
 };
 
 Drupal.views.ajaxView.prototype.attachExposedFormAjax = function() {
diff --git a/drupal7/sites/all/modules/views/modules/field/views_handler_field_field.inc b/drupal7/sites/all/modules/views/modules/field/views_handler_field_field.inc
index b50a0aea..a91e13a0 100644
--- a/drupal7/sites/all/modules/views/modules/field/views_handler_field_field.inc
+++ b/drupal7/sites/all/modules/views/modules/field/views_handler_field_field.inc
@@ -820,7 +820,10 @@ class views_handler_field_field extends views_handler_field {
    * Return an array of items for the field.
    */
   function set_items($values, $row_id) {
-    if (empty($values->_field_data[$this->field_alias]) || empty($values->_field_data[$this->field_alias]['entity'])) {
+    // In some cases the instance on the entity might be easy, see
+    // https://drupal.org/node/1161708 and https://drupal.org/node/1461536 for
+    // more information.
+    if (empty($values->_field_data[$this->field_alias]) || empty($values->_field_data[$this->field_alias]['entity']) || !isset($values->_field_data[$this->field_alias]['entity']->{$this->definition['field_name']})) {
       return array();
     }
 
diff --git a/drupal7/sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc b/drupal7/sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc
index 2d9fe966..c2cf691b 100644
--- a/drupal7/sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc
+++ b/drupal7/sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc
@@ -51,20 +51,21 @@ class views_handler_field_profile_date extends views_handler_field_date {
 
     // But we *can* deal with non-year stuff:
     $date = gmmktime(0, 0, 0, $value['month'], $value['day'], $value['year']);
+
     $replace = array(
       // day
       'd' => sprintf('%02d', $value['day']),
       'D' => NULL,
       'l' => NULL,
       'N' => NULL,
-      'S' => date('S', $date),
+      'S' => gmdate('S', $date),
       'w' => NULL,
       'j' => $value['day'],
       // month
-      'F' => date('F', $date),
+      'F' => gmdate('F', $date),
       'm' => sprintf('%02d', $value['month']),
-      'M' => date('M', $date),
-      'n' => date('n', $date),
+      'M' => gmdate('M', $date),
+      'n' => gmdate('n', $date),
 
       'Y' => $value['year'],
       'y' => substr($value['year'], 2, 2),
diff --git a/drupal7/sites/all/modules/views/modules/system/views_handler_field_file_extension.inc b/drupal7/sites/all/modules/views/modules/system/views_handler_field_file_extension.inc
index 6f9a03fe..b543d8a2 100644
--- a/drupal7/sites/all/modules/views/modules/system/views_handler_field_file_extension.inc
+++ b/drupal7/sites/all/modules/views/modules/system/views_handler_field_file_extension.inc
@@ -10,10 +10,40 @@
  * @ingroup views_field_handlers
  */
 class views_handler_field_file_extension extends views_handler_field {
+  public function option_definition() {
+    $options = parent::option_definition();
+    $options['extension_detect_tar'] = array('default' => FALSE, 'bool' => TRUE);
+    return $options;
+  }
+
+  public function options_form(&$form, &$form_state) {
+    parent::options_form($form, $form_state);
+    $form['extension_detect_tar'] = array(
+      '#type' => 'checkbox',
+      '#title' => t('Detect if tar is part of the extension'),
+      '#description' => t("See if the previous extension is '.tar' and if so, add that, so we see 'tar.gz' or 'tar.bz2' instead of just 'gz'."),
+      '#default_value' => $this->options['extension_detect_tar'],
+    );
+  }
+
   function render($values) {
     $value = $this->get_value($values);
-    if (preg_match('/\.([^\.]+)$/', $value, $match)) {
-      return $this->sanitize_value($match[1]);
+    if (!$this->options['extension_detect_tar']) {
+      if (preg_match('/\.([^\.]+)$/', $value, $match)) {
+        return $this->sanitize_value($match[1]);
+      }
+    }
+    else {
+      $file_parts = explode('.', basename($value));
+      // If there is an extension.
+      if (count($file_parts) > 1) {
+        $extension = array_pop($file_parts);
+        $last_part_in_name = array_pop($file_parts);
+        if ($last_part_in_name === 'tar') {
+          $extension = 'tar.' . $extension;
+        }
+        return $this->sanitize_value($extension);
+      }
     }
   }
 }
diff --git a/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc b/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc
index 7eb868f7..8938ca9f 100644
--- a/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc
+++ b/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc
@@ -98,15 +98,12 @@ class views_handler_filter_term_node_tid extends views_handler_filter_many_to_on
     if ($this->options['type'] == 'textfield') {
       $default = '';
       if ($this->value) {
-        $result = db_select('taxonomy_term_data', 'td')
-          ->fields('td')
-          ->condition('td.tid', $this->value)
-          ->execute();
-        foreach ($result as $term) {
+        $result = taxonomy_term_load_multiple($this->value);
+        foreach ($result as $entity_term) {
           if ($default) {
             $default .= ', ';
           }
-          $default .= $term->name;
+          $default .= entity_label('taxonomy_term', $entity_term);
         }
       }
 
@@ -122,13 +119,14 @@ class views_handler_filter_term_node_tid extends views_handler_filter_many_to_on
     }
     else {
       if (!empty($this->options['hierarchy']) && $this->options['limit']) {
-        $tree = taxonomy_get_tree($vocabulary->vid);
+        $tree = taxonomy_get_tree($vocabulary->vid, 0, NULL, TRUE);
         $options = array();
 
         if ($tree) {
+          // Translation system needs full entity objects, so we have access to label.
           foreach ($tree as $term) {
             $choice = new stdClass();
-            $choice->option = array($term->tid => str_repeat('-', $term->depth) . $term->name);
+            $choice->option = array($term->tid => str_repeat('-', $term->depth) . entity_label('taxonomy_term', $term));
             $options[] = $choice;
           }
         }
@@ -147,8 +145,14 @@ class views_handler_filter_term_node_tid extends views_handler_filter_many_to_on
           $query->condition('tv.machine_name', $vocabulary->machine_name);
         }
         $result = $query->execute();
+
+        $tids = array();
         foreach ($result as $term) {
-          $options[$term->tid] = $term->name;
+          $tids[] = $term->tid;
+        }
+        $entities = taxonomy_term_load_multiple($tids);
+        foreach ($entities as $entity_term) {
+          $options[$entity_term->tid] = entity_label('taxonomy_term', $entity_term);
         }
       }
 
@@ -238,7 +242,7 @@ class views_handler_filter_term_node_tid extends views_handler_filter_many_to_on
     $rc = parent::accept_exposed_input($input);
     if ($rc) {
       // If we have previously validated input, override.
-      if (isset($this->validated_exposed_input)) {
+      if (!$this->is_a_group() && isset($this->validated_exposed_input)) {
         $this->value = $this->validated_exposed_input;
       }
     }
@@ -347,12 +351,9 @@ class views_handler_filter_term_node_tid extends views_handler_filter_many_to_on
 
     if ($this->value) {
       $this->value = array_filter($this->value);
-      $result = db_select('taxonomy_term_data', 'td')
-        ->fields('td')
-        ->condition('td.tid', $this->value)
-        ->execute();
-      foreach ($result as $term) {
-        $this->value_options[$term->tid] = $term->name;
+      $result = taxonomy_term_load_multiple($this->value);
+      foreach ($result as $entity_term) {
+        $this->value_options[$entity_term->tid] = entity_label('taxonomy_term', $entity_term);
       }
     }
     return parent::admin_summary();
diff --git a/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc b/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc
index d7fbb4c9..cf722883 100644
--- a/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc
+++ b/drupal7/sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc
@@ -75,7 +75,9 @@ class views_handler_relationship_node_term_data extends views_handler_relationsh
       $query->addJoin($def['type'], 'taxonomy_vocabulary', 'tv', 'td.vid = tv.vid');
       $query->addJoin($def['type'], 'taxonomy_index', 'tn', 'tn.tid = td.tid');
       $query->condition('tv.machine_name', array_filter($this->options['vocabularies']));
-      $query->addTag('term_access');
+      if (empty($this->query->options['disable_sql_rewrite'])) {
+        $query->addTag('term_access');
+      }
       $query->fields('td');
       $query->fields('tn', array('nid'));
       $def['table formula'] = $query;
diff --git a/drupal7/sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc b/drupal7/sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc
index 9129c017..fe038dad 100644
--- a/drupal7/sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc
+++ b/drupal7/sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc
@@ -22,7 +22,7 @@ class views_handler_field_user_link_cancel extends views_handler_field_user_link
     if ($uid && user_cancel_access($account)) {
       $this->options['alter']['make_link'] = TRUE;
 
-      $text = !empty($this->options['text']) ? $this->options['text'] : t('cancel');
+      $text = !empty($this->options['text']) ? $this->options['text'] : t('Cancel account');
 
       $this->options['alter']['path'] = "user/$uid/cancel";
       $this->options['alter']['query'] = drupal_get_destination();
diff --git a/drupal7/sites/all/modules/views/modules/views.views.inc b/drupal7/sites/all/modules/views/modules/views.views.inc
index 2029aa8b..7c3f4db9 100644
--- a/drupal7/sites/all/modules/views/modules/views.views.inc
+++ b/drupal7/sites/all/modules/views/modules/views.views.inc
@@ -81,6 +81,14 @@ function views_views_data() {
     ),
   );
 
+  $data['views']['messages'] = array(
+    'title' => t('Messages'),
+    'help' => t('Displays messages in the area.'),
+    'area' => array(
+      'handler' => 'views_handler_area_messages',
+    ),
+  );
+
   if (module_exists('contextual')) {
     $data['views']['contextual_links'] = array(
       'title' => t('Contextual Links'),
@@ -110,5 +118,14 @@ function views_views_data() {
     );
   }
 
+  $data['views']['fields_compare'] = array(
+    'title' => t('Fields comparison'),
+    'help' => t('Compare database fields against eachother.'),
+    'filter' => array(
+      'help' => t('Use fields comparison to filter the result of the view.'),
+      'handler' => 'views_handler_filter_fields_compare',
+    )
+  );
+
   return $data;
 }
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_cache.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_cache.inc
index 4d21701f..81f71bfb 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_cache.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_cache.inc
@@ -200,25 +200,28 @@ class views_plugin_cache extends views_plugin {
       $this->storage['head'] = '';
     }
 
+    // Check if the advanced mapping function of D 7.23 is available.
+    $array_mapping_func = function_exists('drupal_array_diff_assoc_recursive') ? 'drupal_array_diff_assoc_recursive' : 'array_diff_assoc';
+
     // Slightly less simple for CSS:
     $css = drupal_add_css();
     $css_start = isset($this->storage['css']) ? $this->storage['css'] : array();
-    $this->storage['css'] = array_diff_assoc($css, $css_start);
+    $this->storage['css'] = $array_mapping_func($css, $css_start);
 
     // Get javascript after/before views renders.
     $js = drupal_add_js();
     $js_start = isset($this->storage['js']) ? $this->storage['js'] : array();
     // If there are any differences between the old and the new javascript then
     // store them to be added later.
-    $this->storage['js'] = array_diff_assoc($js, $js_start);
+    $this->storage['js'] = $array_mapping_func($js, $js_start);
 
     // Special case the settings key and get the difference of the data.
     $settings = isset($js['settings']['data']) ? $js['settings']['data'] : array();
     $settings_start = isset($js_start['settings']['data']) ? $js_start['settings']['data'] : array();
-    $this->storage['js']['settings'] = array_diff_assoc($settings, $settings_start);
+    $this->storage['js']['settings'] = $array_mapping_func($settings, $settings_start);
 
     // Get difference of HTTP headers.
-    $this->storage['headers'] = array_diff_assoc(drupal_get_http_header(), $this->storage['headers']);
+    $this->storage['headers'] = $array_mapping_func(drupal_get_http_header(), $this->storage['headers']);
   }
 
   /**
@@ -253,59 +256,61 @@ class views_plugin_cache extends views_plugin {
   }
 
   function get_results_key() {
-    global $user;
-
     if (!isset($this->_results_key)) {
-
-      $build_info = $this->view->build_info;
-
-      $query_plugin = $this->view->display_handler->get_plugin('query');
-
-      foreach (array('query','count_query') as $index) {
-        // If the default query back-end is used generate SQL query strings from
-        // the query objects.
-        if ($build_info[$index] instanceof SelectQueryInterface) {
-          $query = clone $build_info[$index];
-          $query->preExecute();
-          $build_info[$index] = (string) $query;
-        }
-      }
-      $key_data = array(
-        'build_info' => $build_info,
-        'roles' => array_keys($user->roles),
-        'super-user' => $user->uid == 1, // special caching for super user.
-        'language' => $GLOBALS['language']->language,
-        'base_url' => $GLOBALS['base_url'],
-      );
-      foreach (array('exposed_info', 'page', 'sort', 'order', 'items_per_page', 'offset') as $key) {
-        if (isset($_GET[$key])) {
-          $key_data[$key] = $_GET[$key];
-        }
-      }
-
-      $this->_results_key = $this->view->name . ':' . $this->display->id . ':results:' . md5(serialize($key_data));
+      $this->_results_key = $this->view->name . ':' . $this->display->id . ':results:' . $this->get_cache_key();
     }
 
     return $this->_results_key;
   }
 
   function get_output_key() {
-    global $user;
     if (!isset($this->_output_key)) {
       $key_data = array(
-        'result' => $this->view->result,
-        'roles' => array_keys($user->roles),
-        'super-user' => $user->uid == 1, // special caching for super user.
         'theme' => $GLOBALS['theme'],
-        'language' => $GLOBALS['language']->language,
-        'base_url' => $GLOBALS['base_url'],
       );
-
-      $this->_output_key = $this->view->name . ':' . $this->display->id . ':output:' . md5(serialize($key_data));
+      $this->_output_key = $this->view->name . ':' . $this->display->id . ':output:' . $this->get_cache_key($key_data);
     }
 
     return $this->_output_key;
   }
+
+  /**
+   * Returns cache key.
+   *
+   * @param array $key_data
+   *   Additional data for cache segmentation and/or overrides for default
+   *   segmentation.
+   *
+   * @return string
+   */
+  function get_cache_key($key_data = array()) {
+    global $user;
+
+    $key_data += array(
+      'roles' => array_keys($user->roles),
+      'super-user' => $user->uid == 1, // special caching for super user.
+      'language' => $GLOBALS['language']->language,
+      'base_url' => $GLOBALS['base_url'],
+    );
+
+    if (empty($key_data['build_info'])) {
+      $build_info = $this->view->build_info;
+      foreach (array('query','count_query') as $index) {
+        // If the default query back-end is used generate SQL query strings from
+        // the query objects.
+        if ($build_info[$index] instanceof SelectQueryInterface) {
+          $query = clone $build_info[$index];
+          $query->preExecute();
+          $key_data['build_info'][$index] = array(
+            'sql' => (string) $query,
+            'arguments' => $query->getArguments(),
+          );
+        }
+      }
+    }
+    $key = md5(serialize($key_data));
+    return $key;
+  }
 }
 
 /**
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_display.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_display.inc
index 75a32c51..db124de0 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_display.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_display.inc
@@ -918,7 +918,7 @@ class views_plugin_display extends views_plugin {
   /**
    * Get a full array of handlers for $type. This caches them.
    */
-  function get_handlers($type) {
+  function &get_handlers($type) {
     if (!isset($this->handlers[$type])) {
       $this->handlers[$type] = array();
       $types = views_object_types();
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_display_feed.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_display_feed.inc
index bfd220c5..5eb68e32 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_display_feed.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_display_feed.inc
@@ -37,7 +37,7 @@ class views_plugin_display_feed extends views_plugin_display_page {
   function execute() {
     $output = $this->view->render();
     if (empty($output)) {
-      return drupal_not_found();
+      return MENU_NOT_FOUND;
     }
     print $output;
   }
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_display_page.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_display_page.inc
index 7ca4bf7f..4bcec0bc 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_display_page.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_display_page.inc
@@ -216,11 +216,11 @@ class views_plugin_display_page extends views_plugin_display {
     // display, and arguments should be set on the view.
     $this->view->build();
     if (!empty($this->view->build_info['fail'])) {
-      return drupal_not_found();
+      return MENU_NOT_FOUND;
     }
 
     if (!empty($this->view->build_info['denied'])) {
-      return drupal_access_denied();
+      return MENU_ACCESS_DENIED;
     }
 
     $this->view->get_breadcrumb(TRUE);
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form.inc
index 343eee81..5d546004 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form.inc
@@ -173,7 +173,7 @@ class views_plugin_exposed_form extends views_plugin {
     $view = $this->view;
     $exposed_data = isset($view->exposed_data) ? $view->exposed_data : array();
     $sort_by = isset($exposed_data['sort_by']) ? $exposed_data['sort_by'] : NULL;
-    if (!empty($sort_by)) {
+    if (!empty($sort_by) && $this->view->style_plugin->build_sort()) {
       // Make sure the original order of sorts is preserved
       // (e.g. a sticky sort is often first)
       if (isset($view->sort[$sort_by])) {
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc
index 4f2c2d2a..ca97674e 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc
@@ -71,6 +71,7 @@ class views_plugin_exposed_form_input_required extends views_plugin_exposed_form
         'group_type' => 'group',
         'content' => $this->options['text_input_required'],
         'format' => $this->options['text_input_required_format'],
+        'empty' => TRUE,
       );
       $handler = views_get_handler('views', 'area', 'area');
       $handler->init($this->view, $options);
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_pager.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_pager.inc
index 416d6625..312f54b9 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_pager.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_pager.inc
@@ -107,7 +107,7 @@ class views_plugin_pager extends views_plugin {
    * Get the pager id, if it exists
    */
   function get_pager_id() {
-    return isset($this->options['id']) ? $this->options['id'] : 0;
+    return !empty($this->options['id']) ? $this->options['id'] : 0;
   }
 
   /**
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_pager_full.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_pager_full.inc
index d4c22038..aedb2237 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_pager_full.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_pager_full.inc
@@ -276,7 +276,7 @@ class views_plugin_pager_full extends views_plugin_pager {
     );
     $output = theme($pager_theme, array(
       'tags' => $tags,
-      'element' => $this->options['id'],
+      'element' => $this->get_pager_id(),
       'parameters' => $input,
       'quantity' => $this->options['quantity'],
     ));
@@ -308,11 +308,12 @@ class views_plugin_pager_full extends views_plugin_pager {
     // array hasn't been initialized before.
     $page = isset($_GET['page']) ? explode(',', $_GET['page']) : array();
 
-    for ($i = 0; $i <= $this->options['id'] || $i < count($pager_page_array); $i++) {
+    $pager_id = $this->get_pager_id();
+    for ($i = 0; $i <= $pager_id || $i < count($pager_page_array); $i++) {
       $pager_page_array[$i] = empty($page[$i]) ? 0 : $page[$i];
     }
 
-    $this->current_page = intval($pager_page_array[$this->options['id']]);
+    $this->current_page = intval($pager_page_array[$pager_id]);
 
     if ($this->current_page < 0) {
       $this->current_page = 0;
@@ -348,24 +349,25 @@ class views_plugin_pager_full extends views_plugin_pager {
       // Dump information about what we already know into the globals.
       global $pager_page_array, $pager_total, $pager_total_items, $pager_limits;
       // Set the limit.
-      $pager_limits[$this->options['id']] = $this->options['items_per_page'];
+      $pager_id = $this->get_pager_id();
+      $pager_limits[$pager_id] = $this->options['items_per_page'];
       // Set the item count for the pager.
-      $pager_total_items[$this->options['id']] = $this->total_items;
+      $pager_total_items[$pager_id] = $this->total_items;
       // Calculate and set the count of available pages.
-      $pager_total[$this->options['id']] = $this->get_pager_total();
+      $pager_total[$pager_id] = $this->get_pager_total();
 
       // See if the requested page was within range:
       if ($this->current_page < 0) {
         $this->current_page = 0;
       }
-      else if ($this->current_page >= $pager_total[$this->options['id']]) {
+      else if ($this->current_page >= $pager_total[$pager_id]) {
         // Pages are numbered from 0 so if there are 10 pages, the last page is 9.
-        $this->current_page = $pager_total[$this->options['id']] - 1;
+        $this->current_page = $pager_total[$pager_id] - 1;
       }
 
       // Put this number in to guarantee that we do not generate notices when the pager
       // goes to look for it later.
-      $pager_page_array[$this->options['id']] = $this->current_page;
+      $pager_page_array[$pager_id] = $this->current_page;
     }
   }
 
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_pager_mini.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_pager_mini.inc
index bec48c89..87d55410 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_pager_mini.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_pager_mini.inc
@@ -63,7 +63,7 @@ class views_plugin_pager_mini extends views_plugin_pager_full {
     );
     return theme($pager_theme, array(
       'tags' => $tags,
-      'element' => $this->options['id'],
+      'element' => $this->get_pager_id(),
       'parameters' => $input,
     ));
   }
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_query_default.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_query_default.inc
index 030c5ea0..8a15e8dc 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_query_default.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_query_default.inc
@@ -1365,6 +1365,16 @@ class views_plugin_query_default extends views_plugin_query {
     // Add all query substitutions as metadata.
     $query->addMetaData('views_substitutions', module_invoke_all('views_query_substitutions', $this));
 
+    if (!$get_count) {
+      if (!empty($this->limit) || !empty($this->offset)) {
+        // We can't have an offset without a limit, so provide a very large limit
+        // instead.
+        $limit  = intval(!empty($this->limit) ? $this->limit : 999999);
+        $offset = intval(!empty($this->offset) ? $this->offset : 0);
+        $query->range($offset, $limit);
+      }
+    }
+
     return $query;
   }
 
@@ -1469,16 +1479,8 @@ class views_plugin_query_default extends views_plugin_query {
           $this->pager->execute_count_query($count_query);
         }
 
-        // Let the pager modify the query to add limits.
         $this->pager->pre_execute($query);
 
-        if (!empty($this->limit) || !empty($this->offset)) {
-          // We can't have an offset without a limit, so provide a very large limit instead.
-          $limit  = intval(!empty($this->limit) ? $this->limit : 999999);
-          $offset = intval(!empty($this->offset) ? $this->offset : 0);
-          $query->range($offset, $limit);
-        }
-
         $result = $query->execute();
 
         $view->result = array();
diff --git a/drupal7/sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc b/drupal7/sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc
index 16b0aef7..1de90f79 100644
--- a/drupal7/sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc
+++ b/drupal7/sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc
@@ -142,8 +142,17 @@ class views_plugin_style_jump_menu extends views_plugin_style {
     unset($this->view->row_index);
 
     $default_value = '';
-    if ($this->options['default_value'] && !empty($paths[url($_GET['q'])])) {
-      $default_value = $paths[url($_GET['q'])];
+    if ($this->options['default_value']) {
+      $lookup_options = array();
+      // We need to check if the path is absolute
+      // or else language is not taken in account.
+      if ($this->view->display[$this->view->current_display]->display_options['fields'][$this->options['path']]['absolute']) {
+        $lookup_options['absolute'] = TRUE;
+      }
+      $lookup_url = url($_GET['q'], $lookup_options);
+      if (!empty($paths[$lookup_url])) {
+        $default_value = $paths[$lookup_url];
+      }
     }
 
     ctools_include('jump-menu');
